(function() {
        if (window.fund) {
            return;
        }


        var responseCallbacks = {};
        var uniqueId = 1;

        /** 
        *   用于html页面调用。 
        */
        function navigateTo(params) {
            var jsonStr = generateCallbackId(params);
            fundModule.navigateTo(jsonStr, null);
        }

        function redirectTo(params) {
            var jsonStr = generateCallbackId(params);
            fundModule.redirectTo(jsonStr, null);
        }

        function reLaunch(params) {
            var jsonStr = generateCallbackId(params);
            fundModule.reLaunch(jsonStr, null);
        }

        function navigateBack(params) {
            var jsonStr = generateCallbackId(params);
            fundModule.navigateBack(jsonStr);
        }

        function navigateToMiniProgram(params) {
            var jsonStr = generateCallbackId(params);
            fundModule.navigateToMiniProgram(jsonStr, null);
        }

        function navigateToApp(params) {
            console.log("@cly navigateToApp");
            var jsonStr = generateCallbackId(params);
            fundModule.navigateToApp(jsonStr, null);
        }

        function redirectToApp(params) {
            var jsonStr = generateCallbackId(params);
            fundModule.redirectToApp(jsonStr, null);
        }

        function switchTab(params) {
            var jsonStr = generateCallbackId(params);
            fundModule.switchTab(jsonStr, null);
        }

        function registerPageTag(params) {
            var jsonStr = generateCallbackId(params);
            fundModule.registerPageTag(jsonStr, null);
        }

        function navigateBackPageTag(params) {
            var jsonStr = generateCallbackId(params);
            fundModule.navigateBackPageTag(jsonStr, null);
        }

        function setStorage(params) {
            var jsonStr = generateCallbackId(params);
            fundModule.setStorage(jsonStr, null);
        }
    
        function getStorage(params) {
            var jsonStr = generateCallbackId(params);
            fundModule.getStorage(jsonStr, null);
        }

        function removeStorage(params) {
            var jsonStr = generateCallbackId(params);
            fundModule.removeStorage(jsonStr, null);
        }

        function removeStorageSync(key, params) {
            var jsonStr = generateCallbackId(params);
            return fundModule.removeStorageSync(key, jsonStr);
       }

        function clearStorage(params) {
            var jsonStr = generateCallbackId(params);
            fundModule.clearStorage(jsonStr, null);
        }

        function clearStorageSync() {
            fundModule.clearStorageSync();
        }

        function setStorageSync(params) {
           var result =  fundModule.setStorageSync(JSON.stringify(params));
           return result;
        }

        function getStorageSync(key, params) {
            var jsonStr = generateCallbackId(params);
            return fundModule.getStorageSync(key, jsonStr);
        }

        function setClipboardData(params) {
            var jsonStr = generateCallbackId(params);
            fundModule.setClipboardData(jsonStr, null);
        }

        function getClipboardData(params) {
            var jsonStr = generateCallbackId(params);
            fundModule.getClipboardData(jsonStr, null);
        }

        function request(params) {
            var jsonStr = generateCallbackId(params);
            fundModule.request(jsonStr, null);
        }

        function uploadFile(params) {
            var jsonStr = generateCallbackId(params);
            fundModule.uploadFile(jsonStr, null);
        }

        function downloadFile(params) {
            var jsonStr = generateCallbackId(params);
            fundModule.downloadFile(jsonStr, null);
        }

        function saveFile(params) {
            var jsonStr = generateCallbackId(params);
            fundModule.saveFile(jsonStr, null);
        }

        function getFileDir(params) {
            var jsonStr = generateCallbackId(params);
            fundModule.getFileDir(jsonStr, null);
        }

        function chooseImage(params) {
            var jsonStr = generateCallbackId(params);
            fundModule.chooseImage(jsonStr, null);
        }

        function previewImage(params) {
            var jsonStr = generateCallbackId(params);
            fundModule.previewImage(jsonStr, null);
        }

        function saveImageToPhotosAlbum(params) {
            var jsonStr = generateCallbackId(params);
            fundModule.saveImageToPhotosAlbum(jsonStr, null);
        }

        function showToast(params) {
            var jsonStr = generateCallbackId(params);
            fundModule.showToast(jsonStr, null);
        }

        function hideToast() {
            fundModule.hideToast("", null);
        }

        function showLoading(params) {
            var jsonStr = generateCallbackId(params);
            fundModule.showLoading(jsonStr, null);
        }

        function hideLoading() {
            fundModule.hideLoading("", null);
        }

        function showModal(params) {
            var jsonStr = generateCallbackId(params);
            fundModule.showModal(jsonStr, null);
        }

        function showActionSheet(params) {
            var jsonStr = generateCallbackId(params);
            fundModule.showActionSheet(jsonStr, null);
        }

        function makePhoneCall(params) {
            var jsonStr = generateCallbackId(params);
            fundModule.makePhoneCall(jsonStr, null);
        }

        function getLocation(params) {
            var jsonStr = generateCallbackId(params);
            fundModule.getLocation(jsonStr, null);
        }

        function registerShare(params) {
            var jsonStr = generateCallbackId(params);
            fundModule.registerShare(jsonStr, null);
        }

        function showShare() {
            var jsonStr = generateCallbackId("");
            fundModule.showShare(jsonStr, null);
        }

        function share(params){
            var jsonStr = generateCallbackId(params);
            fundModule.share(jsonStr,null);
        }

        function getSystemInfo(params) {
            var jsonStr = generateCallbackId(params);
            fundModule.getSystemInfo(jsonStr, null);
        }
        
        function getSystemInfoSync(params) {
            console.log("222");
            return fundModule.getSystemInfoSync(params);
        }

        function getNetworkType(params) {
            var jsonStr = generateCallbackId(params);
            fundModule.getNetworkType(jsonStr, null);
        }

        function getNetworkTypeSync(params) {
           return fundModule.getNetworkTypeSync(params);
        }

        function getUserInfo(params) {
            var jsonStr = generateCallbackId(params);
            fundModule.getUserInfo(jsonStr, null);
        }

        function login(params) {
            var jsonStr = generateCallbackId(params);
            fundModule.login(jsonStr, null);
        }

        function getUserInfoSync(params) {
             return fundModule.getUserInfoSync(params);
        }

        function hideKeyboard() {
            fundModule.hideKeyboard();
        }

        function reportMonitor(params) {
            var jsonStr = generateCallbackId(params);
            fundModule.reportMonitor(jsonStr, null);
        }

        function setNavigationBarTitle(params) {
            var jsonStr = generateCallbackId(params);
            fundModule.setNavigationBarTitle(jsonStr, null);
        } 

        function setNavigationBarColor(params) {
            var jsonStr = generateCallbackId(params);
            fundModule.setNavigationBarColor(jsonStr, null);
        }

        function showNavigationBarLoading(params) {
            var jsonStr = generateCallbackId(params);
            fundModule.showNavigationBarLoading(jsonStr, null);
        }

        function hideNavigationBarLoading(params) {
            var jsonStr = generateCallbackId(params);
            fundModule.hideNavigationBarLoading(jsonStr, null);
        }

        function setNavigationBar(params) {
            var jsonStr = generateCallbackId(params);
            fundModule.setNavigationBar(jsonStr, null);
        }

        function scanCode(params) {
            var jsonStr = generateCallbackId(params);
            fundModule.scanCode(jsonStr, null);
        }

        function postMessageToMP(params) {
            var jsonStr = generateCallbackId(params);
            fundModule.postMessageToMP(jsonStr);
        }

        function canIUse(schema) {
            return fundModule.canIUse(schema);
        }

        function emit(params) {
            var jsonStr = generateCallbackId(params);
            fundModule.emit(jsonStr, null);
        }

        function on(params) {
            var jsonStr = generateCallbackId(params);
            fundModule.on(jsonStr, null);
        }

        function off(params) {
            var jsonStr = generateCallbackId(params);
            fundModule.off(jsonStr, null);
        }

        function offAll(params) {
            var jsonStr = generateCallbackId(params);
            fundModule.offAll(jsonStr, null);
        }

        function postMessageToApp(params) {
            var jsonStr = generateCallbackId(params);
            fundModule.postMessageToApp(jsonStr, null);
        }

        function getAccountInfoSync() {
            return fundModule.getAccountInfoSync();
        }

        function presentPage(params) {
            var jsonStr = generateCallbackId(params);
            fundModule.presentPage(jsonStr, null);
        }

        function showTabBarRedDot(params) {
            var jsonStr = generateCallbackId(params);
            fundModule.showTabBarRedDot(jsonStr, null);
        }

        function hideTabBarRedDot(params) {
             var jsonStr = generateCallbackId(params);
             fundModule.hideTabBarRedDot(jsonStr, null);
        }

        function setTabBarBadge(params) {
             var jsonStr = generateCallbackId(params);
             fundModule.setTabBarBadge(jsonStr, null);
        }

        function removeTabBarBadge(params) {
             var jsonStr = generateCallbackId(params);
             fundModule.removeTabBarBadge(jsonStr, null);
        }

        function showTabBar(params) {
             console.log("------------------------------------showTabBar");

             var jsonStr = generateCallbackId(params);
             fundModule.showTabBar(jsonStr, null);
        }

        function hideTabBar(params) {
             var jsonStr = generateCallbackId(params);
             fundModule.hideTabBar(jsonStr, null);
        }

        function setTabBarStyle(params) {
             var jsonStr = generateCallbackId(params);
             fundModule.setTabBarStyle(jsonStr, null);
        }

        function setTabBarItem(params) {
             var jsonStr = generateCallbackId(params);
             fundModule.setTabBarItem(jsonStr, null);
        }

        function isApplicationExist(params) {
            return fundModule.isApplicationExist(params);
        }

        function hideHomeButton(params) {
            var jsonStr = generateCallbackId(params);
            return fundModule.hideHomeButton(params, jsonStr);
        }

        function setMemory(params){
            return fundModule.setMemory(params);
        }

        function getMemory(params){
            return fundModule.getMemory(params);
        }

        function removeMemory(params){
            return fundModule.removeMemory(params);
        }

        function clearMemory(){
            fundModule.clearMemory();
        }

        function getCurrentPages(){
            return JSON.parse(fundModule.getCurrentPages());
        }

        /*    语音听写示例    */

        function init(params){
            var jsonStr = generateCallbackId(params);
            fundModule.init(jsonStr);
        }

        function start(params){
            var jsonStr = generateCallbackId(params);
            fundModule.start(jsonStr);
        }

        function stop(params){
            var jsonStr = generateCallbackId(params);
            fundModule.stop(jsonStr);
        }

        function isListening(params){
            var jsonStr = generateCallbackId(params);
            return fundModule.isListening(jsonStr);
        }

        function cancel(params){
            var jsonStr = generateCallbackId(params);
            fundModule.cancel(jsonStr);
        }

        function destroy(params){
            var jsonStr = generateCallbackId(params);
            fundModule.destroy(jsonStr);
        }

        /*    语音听写示例    */
        
        /**
         * 提供给native调用. 多次回调
         */
        function _invokeJSCallbackAndKeepAlive(callbackJson) {
            execInvokeMethod(callbackJson);
        }
        
        /**
         * 提供给native调用. 一次性回调
         */
        function _invokeJSCallback(callbackJson) {
            var callbackId = execInvokeMethod(callbackJson);
            if (callbackId) {
                delete responseCallbacks[callbackId];
            }
        }


        function _postMessageToWeb(jsonData) {
            var messageEvent = document.createEvent("Event");
            messageEvent.initEvent("message",true,true);
            var jsonObject = JSON.parse(jsonData);
            messageEvent.data = jsonObject.data;
            messageEvent.origin = jsonObject.origin;
            window.dispatchEvent(messageEvent);
        }

        function execInvokeMethod(callbackJson) {
            var message = JSON.parse(callbackJson);
            if (message.callbackId) {
                var responseCallback = responseCallbacks[message.callbackId];
                if (!responseCallback) {
                    return;
                }

                var res = message;
                responseCallback(res);
                return message.callbackId;
            }  
            return undefined;
        }

        function generateCallbackId(params) {
            var convertFunction = function (json) {
                if (params.success || params.fail || params.complete) {
                    if (json.code === 1) {
                        params.success ? params.success(json.data) : ''
                    } else {
                        params.fail ? params.fail(json.data) : ''
                    }
                    params.complete ? params.complete(json.data) : json
                }
            };

            var callbackId = 'fund_' + (uniqueId++) + '_' + new Date().getTime();
            responseCallbacks[callbackId] = convertFunction;
            if ((typeof params == 'string') && params.constructor == String) {
                return params;
            } else {
                if(params == undefined) {
                    params = {};
                }

                params.callbackId = callbackId;
                return JSON.stringify(params);
            }
        }


        var fund = window.fund = {
            navigateTo,
            redirectTo,
            reLaunch,
            navigateBack,
            navigateToMiniProgram,
            navigateToApp,
            redirectToApp,
            switchTab,
            registerPageTag,
            navigateBackPageTag,
            setStorageSync,
            getStorageSync,
            setStorage,
            getStorage,
            removeStorage,
            removeStorageSync,
            clearStorage,
            clearStorageSync,
            setClipboardData,
            getClipboardData,
            request,
            uploadFile, 
            downloadFile,
            saveFile,
            getFileDir,
            chooseImage,
            previewImage,
            saveImageToPhotosAlbum,
            showToast,
            hideToast,
            showLoading,
            hideLoading,
            showModal,
            showActionSheet,
            makePhoneCall,
            getLocation,
            registerShare,
            showShare,
            share,
            getSystemInfo,
            getSystemInfoSync,
            getNetworkType,
            getNetworkTypeSync,
            getUserInfo,
            getUserInfoSync,
            hideKeyboard,
            setNavigationBarTitle,
            setNavigationBarColor,
            setNavigationBar,
            showNavigationBarLoading,
            hideNavigationBarLoading,
            reportMonitor,
            scanCode,
            postMessageToMP,
            login,
            canIUse,
            emit,
            on,
            off,
            offAll,
            postMessageToApp,
            getAccountInfoSync,
            presentPage,
            showTabBarRedDot,
            hideTabBarRedDot,
            setTabBarBadge,
            removeTabBarBadge,
            showTabBar,
            hideTabBar,
            setTabBarStyle,
            setTabBarItem,
            isApplicationExist,
            hideHomeButton,
            setMemory,
            getMemory,
            removeMemory,
            clearMemory,
            getCurrentPages,
            init,
            start,
            stop,
            isListening,
            cancel,
            destroy,
            _postMessageToWeb,
            _invokeJSCallback,
            _invokeJSCallbackAndKeepAlive
        };

        var doc = document;
        var readyEvent = doc.createEvent('Events');
        readyEvent.initEvent('fundJSBridgeReady');
        doc.dispatchEvent(readyEvent);
 })();